package cdac.medinfo.sdk.hl7282.hl7net.testnetwork.localmessages;

import cdac.medinfo.sdk.hl7282.baselibs.messagedictionary.MessageMapReader;
import cdac.medinfo.sdk.hl7282.baselibs.messagedictionary.SegmentItem;
import cdac.medinfo.sdk.hl7282.baselibs.messages.Message;
import cdac.medinfo.sdk.hl7282.baselibs.segments.ACC;
import cdac.medinfo.sdk.hl7282.baselibs.segments.AL1;
import cdac.medinfo.sdk.hl7282.baselibs.segments.DB1;
import cdac.medinfo.sdk.hl7282.baselibs.segments.DG1;
import cdac.medinfo.sdk.hl7282.baselibs.segments.DRG;
import cdac.medinfo.sdk.hl7282.baselibs.segments.EVN;
import cdac.medinfo.sdk.hl7282.baselibs.segments.GT1;
import cdac.medinfo.sdk.hl7282.baselibs.segments.NK1;
import cdac.medinfo.sdk.hl7282.baselibs.segments.OBX;
import cdac.medinfo.sdk.hl7282.baselibs.segments.PD1;
import cdac.medinfo.sdk.hl7282.baselibs.segments.PDA;
import cdac.medinfo.sdk.hl7282.baselibs.segments.PID;
import cdac.medinfo.sdk.hl7282.baselibs.segments.PV1;
import cdac.medinfo.sdk.hl7282.baselibs.segments.PV2;
import cdac.medinfo.sdk.hl7282.baselibs.segments.ROL;
import cdac.medinfo.sdk.hl7282.baselibs.segments.SFT;
import cdac.medinfo.sdk.hl7282.baselibs.segments.UB2;
import cdac.medinfo.sdk.hl7282.commoninterface.IGroup;
import cdac.medinfo.sdk.hl7282.commoninterface.ISegment;
import cdac.medinfo.sdk.hl7282.commoninterface.ISingleCollection;
import cdac.medinfo.sdk.hl7282.utils.EnumHL7System;
import cdac.medinfo.sdk.hl7282.utils.EnumMapModifyMode;
import cdac.medinfo.sdk.hl7282.utils.EnumMessageCode;
import cdac.medinfo.sdk.hl7282.utils.EnumSegmentCardinality;
import cdac.medinfo.sdk.hl7282.utils.EnumSegments;
import cdac.medinfo.sdk.hl7282.utils.EnumTriggerEvent;
import cdac.medinfo.sdk.hl7282.utils.IMap;
import cdac.medinfo.sdk.hl7282.utils.IMessageMapReader;
import cdac.medinfo.sdk.hl7282.utils.ISegmentItem;


/**
 * This sample Custom message is extended from the ADT_A01. 
 *
 */
public class ADT_A99 extends Message
{
	/*Instance of MessageMap*/
	public static IMap objMessageMap = null;
	
	static
	{
 
		//Initializing MessageMapReader for the PATIENTADMINISTRATION System. 
		IMessageMapReader objMessageMapReader = MessageMapReader.createInstance(EnumHL7System.HL7_SYSTEM_PATIENTADMINISTRATION);
		
		//Taking MessageMap for message ADT_A10 from PATIENTADMINISTRATION System.
		IMap objTempMessageMap = objMessageMapReader.getMessageMap(EnumMessageCode.ADT,EnumTriggerEvent.A01);
		
		/*Making clone of the MessageMap of ADT_A01 which leads to ADT_99*/
		objMessageMap = objTempMessageMap.clone();

		/*Creating custom Segment by creating SegmentItem */
		ISegmentItem objZL7SegmentItem = new SegmentItem();
		
		/*Setting user defined Segment name*/
		objZL7SegmentItem.setName(UserDefinedSegmentEnumeration.ZL7);
		
		/*Setting Cardinality of Segment.*/
		objZL7SegmentItem.setSegmentCardinality(EnumSegmentCardinality.SINGLE_COMPULSARY);
		
		//adding it in MessageMap.
		objMessageMap.addSegmentItem(objZL7SegmentItem,6,EnumMapModifyMode.REPLACE);
	}
	
	public ADT_A99()
	{
		super(objMessageMap, "ADT", "A99", "ADT_A99");
	}
	
	/**
	 * Adds Software Segment(SFT) to this message.
	 * @param objSFT Specified Software Segment(SFT)to be added in message.
	 */
	public void addSoftwareSegment(SFT objSFT)
	{
		addSegment(EnumSegments.HL7_SEG_SFT, objSFT);
	}

	/**
	 * Adds collection of Software Segment(SFT) to this message.
	 * @param objSFTSegmentCollection Collection of Software Segments to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addSoftwareSegment(ISingleCollection<SFT> objSFTSegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objSFTSegmentCollection;
		addSegment(EnumSegments.HL7_SEG_SFT, (ISingleCollection<ISegment>)objSegmentCollection);
	}
	
	/**
	 * Retrieves Collection of Software Segments(SFT) present in this message.
	 * @return ISingleCollection<SFT> - Collection of Software Segments(SFT) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<SFT> getSoftwareSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_SFT);
		return (ISingleCollection<SFT>)objSegmentCollection;
	}

	/**
	 * Retrieves Event Type(EVN) segment present in this message
	 * @return EVN - Specified EVN Segment
	 */
	public EVN getEventTypeSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_EVN);
		if(objSingleCollection != null)
			return (EVN)objSingleCollection.elementAt(0);
		return null;
	}
	

	/**
	 * Sets value of Event Type segment for this message,overwrites if already present.
	 * @param objEVN Specified EVN Segment
	 */
	public void setEventTypeSegment(EVN objEVN)
	{
		setSegment(EnumSegments.HL7_SEG_EVN,objEVN);
	}

	/**
	 * Retrieves Patient Identification(PID) segment present in this message.
	 * @return PID - Specified Patient Identification Segment
	 */
	public PID getPatientIdentificationSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_PID);
		if(objSingleCollection != null)
			return (PID)objSingleCollection.elementAt(0);
		return null;
	}
	/**
	 * Sets value of PID segment for this message,overwrites if already present.
	 * @param objPID Specified PID Segment
	 */
	public void setPatientIdentificationSegment(PID objPID)
	{
		setSegment(EnumSegments.HL7_SEG_PID,objPID);
	}

	/**
	 * Retrieves Additional Demographics segment(PD1) present in this message.
	 * @return PD1 - Specified Additional Demographics(PD1) Segment.
	 */
	public PD1 getAdditinalDemographicsSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_PD1);
		if(objSingleCollection != null)
			return (PD1)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of Additional Demographics segment(PD1) for this message,overwrites if already present.
	 * @param objPD1 Specified Additional Demographics(PD1) Segment.
	 */
	public void setAdditinalDemographicsSegment(PD1 objPD1)
	{
		setSegment(EnumSegments.HL7_SEG_PD1,objPD1);
	}

	/**
	 * Adds Role Segment(ROL) to this message.
	 * @param objROL Specified Role Segment to be added in message.
	 */
	public void addPatientIdentificationRoleSegment(ROL objROL)
	{
		addSegment(EnumSegments.HL7_SEG_ROL_PATIENT_IDENTIFICATION, objROL);
	}

	/**
	 * Adds collection of Role Segments(ROL) to this message.
	 * @param objROLSegmentCollection Collection of Role Segment(ROL) to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addPatientIdentificationRoleSegment(ISingleCollection<ROL> objROLSegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objROLSegmentCollection;
		addSegment(EnumSegments.HL7_SEG_ROL_PATIENT_IDENTIFICATION, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Role Segment(ROL) present in this message.
	 * @return ISingleCollection<ROL> - Collection of Role Segment(ROL) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<ROL> getPatientIdentificationRoleSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_ROL_PATIENT_IDENTIFICATION);
		return (ISingleCollection<ROL>)objSegmentCollection;
	}

	/**
	 * Adds Next of Kin/Associated Parties Segment(NK1) to this message.
	 * @param objNK1 Specified Next of Kin/Associated Parties Segment(NK1) to add in message.
	 */
	public void addNextOfKinOrAssociatedPartiesSegment(NK1 objNK1)
	{
		addSegment(EnumSegments.HL7_SEG_NK1, objNK1);
	}

	/**
	 * Adds collection of Role Segments(ROL) to this message.
	 * @param objNK1SegmentCollection Collection of Next of Kin/Associated Parties Segment(NK1) to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addNextOfKinOrAssociatedPartiesSegment(ISingleCollection<NK1> objNK1SegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objNK1SegmentCollection;
		addSegment(EnumSegments.HL7_SEG_NK1, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Next of Kin/Associated Parties Segment(NK1) present in this message.
	 * @return ISingleCollection<NK1> - Collection of Next of Kin/Associated Parties Segment(NK1) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<NK1> getNextOfKinOrAssociatedPartiesSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_NK1);
		return (ISingleCollection<NK1>)objSegmentCollection;
	}

	/**
	 * Retrieves Patient Visit(PV1) segment present in this message
	 * @return PV1 - Specified PV1 Segment
	 */
	public PV1 getPatientVisitSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_PV1);
		if(objSingleCollection != null)
			return (PV1)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of Patient Visit segment for this message,overwrites if already present.
	 * @param objPV1 Specified PV1 Segment
	 */
	public void setPatientVisitSegment(PV1 objPV1)
	{
		setSegment(EnumSegments.HL7_SEG_PV1,objPV1);
	}

	/**
	 * Retrieves Patient Visit Additional Info(PV2) segment present in this message.
	 * @return PV2 - Specified Patient Visit Additional Info(PV2) Segment
	 */
	public PV2 getPatientVisitAdditionalInfoSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_PV2);
		if(objSingleCollection != null)
			return (PV2)objSingleCollection.elementAt(0);
		return null;
	}
	/**
	 * Sets value of Patient Visit Additional Info(PV2) segment for this message,overwrites if already present.
	 * @param objPV2 Specified PV2 Segment
	 */
	public void setPatientVisitAdditionalInfoSegment(PV2 objPV2)
	{
		setSegment(EnumSegments.HL7_SEG_PV2,objPV2);
	}

	/**
	 * Retrieves ZSegment (ZL7) segment present in this message
	 * @return ZL7 - Specified ZL7 Segment
	 */
	public ZL7 getZSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(UserDefinedSegmentEnumeration.ZL7);
		if(objSingleCollection != null)
			return (ZL7)objSingleCollection.elementAt(0);
		return null;
	}
	
	/**
	 * Sets value of ZSegment (ZL7) segment for this message,overwrites if already present.
	 * @param objZL7 Specified ZL7 Segment
	 */
	public void setZSegment(ZL7 objZL7)
	{
		setSegment(UserDefinedSegmentEnumeration.ZL7,objZL7);
	}

	/**
	 * Adds Role Segment(ROL) to this message.
	 * @param objROL Specified Role Segment to be added in message.
	 */
	public void addPatientVisitRoleSegment(ROL objROL)
	{
		addSegment(EnumSegments.HL7_SEG_ROL_PATIENT_VISIT, objROL);
	}

	/**
	 * Adds collection of Role Segments(ROL) to this message.
	 * @param objROLSegmentCollection Collection of Role Segment(ROL) to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addPatientVisitRoleSegment(ISingleCollection<ROL>  objROLSegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objROLSegmentCollection;
		addSegment(EnumSegments.HL7_SEG_ROL_PATIENT_VISIT, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Role Segment(ROL) present in this message.
	 * @return ISingleCollection<ROL> - Collection of Role Segment(ROL) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<ROL> getPatientVisitRoleSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_ROL_PATIENT_VISIT);
		return (ISingleCollection<ROL>)objSegmentCollection;
	}

	/**
	 * Adds Disability Information(DB1) to this message.
	 * @param objDB1 Specified Disability Information Segment to be added in message.
	 */
	public void addDisabilityInformationSegment(DB1 objDB1)
	{
		addSegment(EnumSegments.HL7_SEG_DB1, objDB1);
	}

	/**
	 * Adds collection of Disability Information(DB1) to this message.
	 * @param objDB1SegmentCollection Collection of Disability Information(DB1) segment to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addDisabilityInformationSegment(ISingleCollection<DB1>  objDB1SegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objDB1SegmentCollection;
		addSegment(EnumSegments.HL7_SEG_DB1, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Disability Information(DB1) present in this message.
	 * @return ISingleCollection<DB1> - Collection of Disability Information(DB1) segment present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<DB1> getDisabilityInformationSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_DB1);
		return (ISingleCollection<DB1>)objSegmentCollection;
	}

	/**
	 * Adds Observation Or Result(OBX) to this message.
	 * @param objOBX Specified Observation Or Result Segment to be added in message.
	 */
	public void addObservationOrResultSegment(OBX objOBX)
	{
		addSegment(EnumSegments.HL7_SEG_OBX, objOBX);
	}

	/**
	 * Adds collection of Observation Or Result(OBX) to this message.
	 * @param objOBXSegmentCollection Collection of Observation Or Result(OBX) to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addObservationOrResultSegment(ISingleCollection<OBX>  objOBXSegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objOBXSegmentCollection;
		addSegment(EnumSegments.HL7_SEG_OBX, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Observation Or Result(OBX) present in this message.
	 * @return ISingleCollection<OBX> - Collection of Observation Or Result(OBX) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<OBX> getObservationOrResultSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_OBX);
		return (ISingleCollection<OBX>)objSegmentCollection;
	}

	/**
	 * Adds Allergy Information(AL1) to this message.
	 * @param objAL1 Specified Allergy Information(AL1) Segment to be added in message.
	 */
	public void addAllergyInformationSegment(AL1 objAL1)
	{
		addSegment(EnumSegments.HL7_SEG_AL1, objAL1);
	}

	/**
	 * Adds collection of Allergy Information(AL1) to this message.
	 * @param objAL1SegmentCollection Collection of Allergy Information(AL1) to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addAllergyInformationSegment(ISingleCollection<AL1>  objAL1SegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objAL1SegmentCollection;
		addSegment(EnumSegments.HL7_SEG_AL1, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Allergy Information(AL1) present in this message.
	 * @return ISingleCollection<AL1> - Collection of Allergy Information(AL1) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<AL1> getAllergyInformationSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_AL1);
		return (ISingleCollection<AL1>)objSegmentCollection;
	}

	/**
	 * Adds Diagnosis Information(DG1) to this message.
	 * @param objDG1 Specified Diagnosis Information(DG1) Segment to this message.
	 */
	public void addDiagnosisInformationSegment(DG1 objDG1)
	{
		addSegment(EnumSegments.HL7_SEG_DG1, objDG1);
	}

	/**
	 * Adds collection of Diagnosis Information(DG1) to this message.
	 * @param objDG1SegmentCollection Collection of Diagnosis Information(DG1)segments to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addDiagnosisInformationSegment(ISingleCollection<DG1>  objDG1SegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objDG1SegmentCollection;
		addSegment(EnumSegments.HL7_SEG_DG1, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Diagnosis Information(DG1) present in this message.
	 * @return ISingleCollection<DG1> - Collection of Diagnosis Information(DG1) segments present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<DG1> getDiagnosisInformationSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_DG1);
		return (ISingleCollection<DG1>)objSegmentCollection;
	}

	/**
	 * Retrieves Diagnosis Related Group segment(DRG) present in this message.
	 * @return DRG - Specified Diagnosis Related Group(DRG) Segment.
	 */
	public DRG getDiagnosisRelatedGroupSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_DRG);
		if(objSingleCollection != null)
			return (DRG)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of Diagnosis Related Group segment(DRG) for this message,overwrites if already present.
	 * @param objDRG Specified Diagnosis Related Group(DRG) Segment.
	 */
	public void setDiagnosisRelatedGroupSegment(DRG objDRG)
	{
		setSegment(EnumSegments.HL7_SEG_DRG,objDRG);
	}

	/**
	 * Retrieves Accident Information segment(ACC) present in this message.
	 * @return ACC - Specified Accident Information(ACC) Segment.
	 */
	public ACC getAccidentInformationSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_ACC);
		if(objSingleCollection != null)
			return (ACC)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of Accident Information segment(ACC) for this message,overwrites if already present.
	 * @param objACC Specified Accident Information(ACC) Segment.
	 */
	public void setAccidentInformationSegment(ACC objACC)
	{
		setSegment(EnumSegments.HL7_SEG_ACC,objACC);
	}

	/**
	 * Retrieves Universal Bill Information segment(UB1) present in this message.
	 * @return UB1 - Specified Universal Bill Information(UB1) Segment.
	 */
//	public UB1 getUniversalBillInformationSegment()
//	{
//		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_UB1);
//		if(objSingleCollection != null)
//			return (UB1)objSingleCollection.elementAt(0);
//		return null;
//	}

	/**
	 * Sets value of Universal Bill Information segment(UB1) for this message,overwrites if already present.
	 * @param objUB1 Specified Universal Bill Information(UB1) Segment.
	 */
/*	public void setUniversalBillInformationSegment(UB1 objUB1)
	{
		setSegment(EnumSegments.HL7_SEG_UB1,objUB1);
	}*/

	/**
	 * Adds Guarantor(GT1) to this message.
	 * @param objGT1 Specified Guarantor Segment to this message.
	 */
	public void addGuarantorSegment(GT1 objGT1)
	{
		addSegment(EnumSegments.HL7_SEG_GT1, objGT1);
	}

	/**
	 * Adds collection of Guarantor(GT1) to this message.
	 * @param objGT1SegmentCollection Collection of Guarantor(GT1) to add in this message
	 */
	@SuppressWarnings("unchecked")
	public void addGuarantorSegment(ISingleCollection<GT1>  objGT1SegmentCollection)
	{
		ISingleCollection<?> objSegmentCollection =  objGT1SegmentCollection;
		addSegment(EnumSegments.HL7_SEG_GT1, (ISingleCollection<ISegment>)objSegmentCollection);
	}

	/**
	 * Retrieves Collection of Guarantor(GT1) present in this message.
	 * @return ISingleCollection<GT1> - Collection of Guarantor(GT1) present in this message.
	 */
	@SuppressWarnings("unchecked")
	public ISingleCollection<GT1> getGuarantorSegments()
	{
		ISingleCollection<?> objSegmentCollection = getSegment(EnumSegments.HL7_SEG_GT1);
		return (ISingleCollection<GT1>)objSegmentCollection;
	}

	/**
	 * Retrieves Universal Bill 92 Information segment(UB2) present in this message.
	 * @return UB2 - Universal Bill 92 Information(UB2) Segment.
	 */
	public UB2 getUniversalBill92InformationSegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_UB2);
		if(objSingleCollection != null)
			return (UB2)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of Universal Bill 92 Information segment(UB2) for this message,overwrites if already present.
	 * @param objUB2 Specified Universal Bill 92 Information(UB2) Segment.
	 */
	public void setUniversalBill92InformationSegment(UB2 objUB2)
	{
		setSegment(EnumSegments.HL7_SEG_UB2,objUB2);
	}

	/**
	 * Retrieves Patient Death and Autopsy segment(PDA) present in this message.
	 * @return PDA - Patient Death and Autopsy(PDA) Segment.
	 */
	public PDA getPatientDeathandAutopsySegment()
	{
		ISingleCollection<ISegment> objSingleCollection = getSegment(EnumSegments.HL7_SEG_PDA);
		if(objSingleCollection != null)
			return (PDA)objSingleCollection.elementAt(0);
		return null;
	}

	/**
	 * Sets value of Patient Death and Autopsy segment(PDA) for this message,overwrites if already present.
	 * @param objPDA Specified Patient Death and Autopsy(PDA) Segment.
	 */
	public void setPatientDeathandAutopsySegment(PDA objPDA)
	{
		setSegment(EnumSegments.HL7_SEG_PDA,objPDA);
	}

	/**
	 * Retrieves Collection of PROCEDURE GROUP present in this message.
	 * @return ISingleCollection<Group> - Collection of PROCEDURE Group present in this Message.
	 */
	public ISingleCollection<IGroup> getProcedureGroups()
	{
		return getGroup(EnumSegments.HL7_GROUP_PROCEDURE);
	}

	/**
	 * Adds Collection of PROCEDURE GROUP to this message.
	 * @param objSingleCollection - Specified PROCEDURE GROUP Collection.
	 */
	public void addProcedureGroups(ISingleCollection<IGroup> objSingleCollection)
	{
		addGroup(EnumSegments.HL7_GROUP_PROCEDURE, objSingleCollection);
	}

	/**
	 * Adds PROCEDURE GROUP to this message.
	 * @param objGroup Specified PROCEDURE GROUP.
	 */
	public void addProcedureGroup(IGroup objGroup)
	{
		addGroup(EnumSegments.HL7_GROUP_PROCEDURE, objGroup);
	}

	/**
	 * Retrieves Collection of INSURANCE GROUP present in this message.
	 * @return ISingleCollection<Group> - Collection of INSURANCE Group present in this Message.
	 */
	public ISingleCollection<IGroup> getInsuranceGroups()
	{
		return getGroup(EnumSegments.HL7_GROUP_INSURANCE);
	}

	/**
	 * Adds Collection of INSURANCE GROUP to this message.
	 * @param objSingleCollection - Specified INSURANCE GROUP Collection.
	 */
	public void addInsuranceGroups(ISingleCollection<IGroup> objSingleCollection)
	{
		addGroup(EnumSegments.HL7_GROUP_INSURANCE, objSingleCollection);
	}

	/**
	 * Adds INSURANCE GROUP to this message.
	 * @param objGroup Specified INSURANCE GROUP.
	 */
	public void addInsuranceGroup(IGroup objGroup)
	{
		addGroup(EnumSegments.HL7_GROUP_INSURANCE, objGroup);
	}
}
